<?php
/**
*
* @package Donation In Profile
* @copyright (c) 2015 BruninoIt
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*/
namespace bruninoit\dip\event;
/**
* @ignore
*/
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
/**
* Event listener
*/
class dip implements EventSubscriberInterface
{
	static public function getSubscribedEvents()
	{
		return array(
		'core.user_setup'						=> 'load_language',
			'core.viewtopic_modify_post_row'					=> 'post',
'core.viewtopic_cache_user_data' => 'cache',
	//		'core.permissions'		=>'permission_dip',

			'core.memberlist_view_profile'					=> 'profile_list_dip',

//ucp
'core.ucp_profile_modify_profile_info'					=> 'ucp_profile_modify_profile_info',
		//	'core.ucp_profile_validate_profile_info'				=> 'ucp_profile_validate_profile_info',
			'core.ucp_profile_info_modify_sql_ary'				=> 'ucp_profile_info_modify_sql_ary',

			);
	}
	/* @var \phpbb\template\template */
	protected $template;
	/** @var \phpbb\db\driver\driver_interface */
	protected $db;
	/** @var \phpbb\user */
	protected $user;
	protected $root_path;
	protected $phpEx;
	/** @var \phpbb\auth\auth */
	protected $auth;
    /** @var \phpbb\controller\helper */
    protected $controller_helper;
    protected $request;
	
	/**
	* Constructor
	*
	* @param \phpbb\controller\helper	$helper		Controller helper object
	* @param \phpbb\template			$template	Template object
	*/
	public function __construct(\phpbb\controller\helper $controller_helper, \phpbb\template\template $template, \phpbb\db\driver\driver_interface $db, \phpbb\user $user, $root_path, $phpEx, \phpbb\auth\auth $auth, \phpbb\request\request $request)	{
        $this->controller_helper = $controller_helper;
        $this->template = $template;
		$this->db = $db;
		$this->user = $user;
		$this->root_path = $root_path;
		$this->phpEx   = $phpEx;
		$this->auth = $auth;
      $this->request = $request;
      $this->max_char = 100; //limit of characters
	}
	

	public function profile_list_dip($event)
	{
    	$member = $event['member'];
	$user_id = (int) $member['user_id'];	

$item = $member['ditem'];
$mail = $member['dmail'];
$item = urlencode($item);
$mail = urlencode($mail);
if($item and $mail)
{
$type = $this->user->lang['DIP_LANG'];
$url = "https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=$mail&lc=US&item_name=$item&no_note=0&currency_code=$type&bn=PP%2dDonationsBF%3abtn_donateCC_LG%2egif%3aNonHostedGuest";
}else{
$url = false;
}
		if($url)
			{
			$this->template->assign_var('U_DONATION', $url);
			}
}


	public function permission_dip($event)
	{
	$permissions = $event['permissions'];
	$permissions['u_dip'] = array('lang' => 'ACL_U_DIP', 'cat' => 'misc');
	}
	
	public function load_language($event)
	{
		$lang_set_ext = $event['lang_set_ext'];
		$lang_set_ext[] = array(
			'ext_name' => 'bruninoit/dip',
			'lang_set' => 'common',
		);
		$event['lang_set_ext'] = $lang_set_ext;
	}

public function cache($event)
{
$a = $event['user_cache_data'];
$row = $event['row'];
$a['dmail'] = $row['dmail'];
$a['ditem'] = $row['ditem'];
//echo $row['dmail'] . $row['ditem'];
$event['user_cache_data'] = $a;
}
	public function post($event)
	{
$rowmessage=$event['post_row'];
$title=$rowmessage['POST_SUBJECT'];
$text=$rowmessage['MESSAGE'];
$id=$rowmessage['POST_ID'];
$uid = $event['poster_id'];
$ur = $event['user_poster_data'];
$item = $ur['ditem'];
$mail = $ur['dmail'];
$item = urlencode($item);
$mail = urlencode($mail);
//$url = $this->helper->route('bruninoit_dip_controller', array('u' => $uid));
/*
%40 @
%2e .
*/
if($item and $mail)
{
$type = $this->user->lang['DIP_LANG']; 
$url = "https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=$mail&lc=US&item_name=$item&no_note=0&currency_code=$type&bn=PP%2dDonationsBF%3abtn_donateCC_LG%2egif%3aNonHostedGuest";
}else{
$url = false;
}
//echo $url;
$rowmessage['DONATION']=$url;
$event['post_row']=$rowmessage;

    }


public function ucp_profile_modify_profile_info($event)
	{
			$ditem=  $this->request->variable('ditem', $this->user->data['ditem']);

		$dmail =  $this->request->variable('dmail', $this->user->data['dmail']);

			$event['data'] = array_merge($event['data'], array(
				'dmail'		=> empty($dmail) ? '' : $dmail,
				'ditem'		=> empty($ditem) ? '' : $ditem,
			));

			$this->add_field($event['data']['dmail'], $event['data']['ditem']);
	}

	public function ucp_profile_validate_profile_info($event)
	{
			$array = $event['error'];
			if (!function_exists('validate_data'))
			{
				include($this->phpbb_root_path . 'includes/functions_user.' . $this->php_ext);
			}
			$validate_array = array(
				'ditem'	=> array('string', false, 0, 12),
				'dmail'	=> array('string', false, 0, 12),

			);
			$error = validate_data($event['data'], $validate_array);
			$event['error'] = array_merge($array, $error);
		
	}

	
	public function ucp_profile_info_modify_sql_ary($event)
	{
			$event['sql_ary'] = array_merge($event['sql_ary'], array(
		'dmail'	=> $event['data']['dmail'],
				'ditem'	=> $event['data']['ditem'],
			));
		
	}


	private function add_field($dmail, $ditem)
	{
		$this->template->assign_vars(array(
			'DITEM'						=> $ditem,
			'DMAIL'							=> $dmail,
		));
	}
}



